﻿using System;
using System.Collections.Generic;

namespace Task4
{
    class Program
    {
        public struct Node
        {
            public int PFrom;
            public char PType;

            public Node(int PFrom, char PType)
            {
                this.PFrom = PFrom;
                this.PType = PType;
            }

            public string ConstructPath()
            {
                return PFrom != -1 ? Nodes[PFrom].ConstructPath() + PType : "";
            }

            public static bool operator ==(Node node1, Node node2)
            {
                return node1.PFrom == node2.PFrom && node1.PType == node2.PType;
            }

            public static bool operator !=(Node node1, Node node2)
            {
                return !(node1 == node2);
            }
        }

        public static int n, m;
        public static bool t;
        public static Node[] Nodes;
        public static string[] Schemes;
        public static long[] SchemeCosts;

        static void Main(string[] args)
        {
            string[] tmp = Console.ReadLine().Split();
            n = Convert.ToInt32(tmp[0]);
            m = Convert.ToInt32(tmp[1]);
            t = tmp[2] == "1";
            Nodes = new Node[n + 1];
            Nodes[0] = new Node(-1, '\0');
            Schemes = new string[m];
            SchemeCosts = new long[m];
            Nodes[1] = new Node(-1, '\0');
            bool[] table = new bool[n + 1];
            table[0] = table[1] = false;
            for (int i = 2; i < n + 1; i++)
            {
                table[i] = true;
            }

            bool secondexflag = true;

            for (int i = 2; i < n + 1; i++)
            {
                tmp = Console.ReadLine().Split();
                int from = Convert.ToInt32(tmp[0]);
                if (from != i - 1) { secondexflag = false; }
                Nodes[i] = new Node(from, tmp[1][0]);
                table[from] = false;
            }

            bool firstexflag = true;

            for (int i = 0; i < m; i++)
            {
                tmp = Console.ReadLine().Split();
                SchemeCosts[i] = Convert.ToInt64(tmp[0]);
                Schemes[i] = tmp[1];
                if (tmp[1].Length != 1) { firstexflag = false; }
            }
            string[] paths = new string[Array.FindAll(table, (bool b) => { return b; }).Length];
            int counter = 0;
            for (int i = 0; i < n+1; i++)
            {
                if(table[i])
                {
                    paths[counter++] = Nodes[i].ConstructPath();
                }
            }
            if (firstexflag)
            {
                long result = 0;
                for (int i = 2; i < n + 1; i++)
                {
                    result += SchemeCosts[Array.IndexOf(Schemes, Nodes[i].PType.ToString())];
                }
                Console.WriteLine(result);
            }
            else if (secondexflag)
            {

            }
            else
            {

            }
#if DEBUG
            Console.ReadKey();
#endif
        }
    }
}
